--[[
rss_conky by arclance

own_window_title rss_conky
created     : 2012-07-11
last updated: 2012-07-24

Changelog
v1.3 - 2012-07-24 
	add mangaupdates section

v1.2 - 2012-07-17
	added cups_and_saucers clock code to run off of this conky.

v1.1.1 - 2012-07-15
	added deadbeef, dunst, and octave rss feeds

v1.1 - 2012-07-14
	add timestamps to output
	use color settings based on age of each rss feed entry
	added conky, fluxbox, hugin, spacefm, udevil, mplayer2, and smplayer2 rss feeds
]]

require 'cairo'

--#### Colors ####
color0_R,color0_G,color0_B,color0_A = (204/255),(153/255),0,1 -- Yellow #CC9900
color1_R,color1_G,color1_B,color1_A = (238/255),(118/255),0,1 -- Orange #EE7600
color2_R,color2_G,color2_B,color2_A = (139/255),0,0,1 -- Red #8B0000
color3_R,color3_G,color3_B,color3_A = (139/255),0,0,1 -- Shade Color #8B0000
--## gradient colors
color4_R,color4_G,color4_B = 1,(204/255),0 -- Dark Yellow #FFCC00
color5_R,color5_G,color5_B = (204/255),0,0 -- Other Red #CC0000
--## hddtemp colors
color6_R,color6_G,color6_B,color6_A = (238/255),0,0,1 -- hddtemp red #EE0000
color7_R,color7_G,color7_B,color7_A = 1,(128/255),0,1 -- hddtemp orange #FF8000
color8_R,color8_G,color8_B,color8_A = (238/255),(238/255),0,1 -- hddtemp yellow #EEEE00
color9_R,color9_G,color9_B,color9_A = (165/255),0,1,1 -- current appointment purple #A500FF
--#### End Colors ####
--#### Font ####
font = "DejaVu Sans Mono"
font2 = "WenQuanYi Micro Hei Mono"
--
fontClock = "LCDMono2"
clockTime_fsize = 31
clockDate_fsize = 24
fSize = 13 -- Top Output Font Size
--#######
xCenter = 958
yCenter = 118

if tonumber(conky_parse('${updates}')) < 2 then
	kvirc_data = nil
	rss_data = nil
	conky_mem_res_min = nil
	lua_mem_used_min = nil
end --# if tonumber(conky_parse('${updates}')) < 2 then

function conky_main()
	if conky_window == nil then return end
	local bg_color = assert(loadfile("/media/Linux_Data/bin/Conky/currentBGLua_log.txt"))()
	--local bg_color = {1,1,1,0.7}
	local cs = cairo_xlib_surface_create(conky_window.display, conky_window.drawable, conky_window.visual, conky_window.width, conky_window.height)
    local cr = cairo_create(cs)
    --### Draw Clock
	cairo_set_antialias (cr, CAIRO_ANTIALIAS_SUBPIXEL)
	cr = draw_bg(cr,bg_color)
	--cr = draw_bg_clock(cr,bg_color)
	display_table_settings(cr)
	local currentTime = os.date("%I:%M:%S")
	local currentDate = os.date("%a %d %b")
	cairo_select_font_face (cr, fontClock, CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL)
	cairo_set_font_size (cr, clockTime_fsize)
	cr = draw_shaded_text(cr, currentTime, (xCenter - 65), (yCenter - 7), {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
	cairo_set_font_size (cr, clockDate_fsize)
	cr = draw_shaded_text(cr, currentDate, (xCenter - 59), (yCenter + 34), {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--### End Clock
	--### Start RSS
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_MITER) --# in case of wacky defaults
	cairo_set_antialias (cr, CAIRO_ANTIALIAS_NONE) --# don't antialias outline it is too thin and gets blurred
	local extents = cairo_text_extents_t:create()
	tolua.takeownership(extents)
	cairo_select_font_face (cr, font2, CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL)
	cairo_set_font_size (cr, fSize)
	cairo_text_extents(cr, "|", extents)
	local vBar_x_advance = extents.x_advance - 1
	cairo_text_extents(cr, '-', extents)
	local dash_x_advance = extents.x_advance
	cairo_text_extents(cr, '/', extents)
	local slash_x_advance = extents.x_advance
	--#################################################
	local blx = 2
	local bly = 12
	--##### kvirc highlight log #####
	local kvirc_log = io.popen("tail --lines=1 /path/to/kvircHighlight_lua_log.txt")
	local kvirc_current = kvirc_log:read("*l")
	kvirc_log:close()
	kvirc_log = nil
	kvirc_current = assert(loadstring(kvirc_current))
	kvirc_current = kvirc_current()
	if (kvirc_current ~= nil) and (kvirc_current ~= "") and (type(kvirc_current) == "table") then --# if file is empty (due to external script and lua script trying to open it at the same time) do nothing
		kvirc_data = kvirc_current
	end --# if if (updates_function ~= nil) and (updates_function ~= "") and (type(updates_function) == "table") then
	local timeEpoch = os.time()
	if (timeEpoch - 3600) < kvirc_data[1][1] then
		timeColor = {0.64706,0,1,1}
		shadeColor = {0,0,0,1}
	elseif (timeEpoch - (3600*3)) < kvirc_data[1][1] then
		timeColor = {0,1,0,1}
		shadeColor = {0,0,0,1}
	elseif (timeEpoch - (3600*6)) < kvirc_data[1][1] then
		timeColor = {0,0.6,0,1}
		shadeColor = {0,0,0,1}
	elseif (timeEpoch - (3600*12)) < kvirc_data[1][1] then
		timeColor = {color5_R,color5_G,color5_B,1}
		shadeColor = {0.3,0.3,0.3,1}
	elseif (timeEpoch - (86400*1)) < kvirc_data[1][1] then
		timeColor = {1,0,0,1}
		shadeColor = {0.3,0.3,0.3,1}
	elseif (timeEpoch - (86400*3)) < kvirc_data[1][1] then
		timeColor = {color7_R,color7_G,color7_B,color7_A}
		shadeColor = {color3_R,color3_G,color3_B,color3_A}
	elseif (timeEpoch - (86400*7)) < kvirc_data[1][1] then
		timeColor = {color8_R,color8_G,color8_B,color8_A}
		shadeColor = {color3_R,color3_G,color3_B,color3_A}
	else
		timeColor = {color0_R,color0_G,color0_B,color0_A}
		shadeColor = {color3_R,color3_G,color3_B,color3_A}
	end --# 
	cr = draw_shaded_text(cr, kvirc_data[1][2], blx, bly, timeColor, shadeColor)
	cairo_text_extents(cr, kvirc_data[1][2], extents)
	blx = blx + extents.x_advance + 1
	cr = draw_shaded_text(cr, '|', blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	blx = blx + vBar_x_advance
	cr = draw_shaded_text(cr, kvirc_data[2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
	if kvirc_data[3] ~= "" then
		cairo_text_extents(cr, kvirc_data[2], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '|', blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, kvirc_data[3], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if kvirc_data[2] ~= "" then
	--##### end kvirc highlight log #####
	--##### Anime RSS Feeds  #####
	cairo_xlib_surface_set_size(cs, 916, conky_window.height)
	local rss_function = assert(loadfile("/path/to/conky_unifiedRSS_CB10_lua_log.txt"))
	rss_function = assert(rss_function())
	if (rss_function ~= nil) and (rss_function ~= "") and (type(rss_function) == "table") then --# if file is empty (due to external script and lua script trying to open it at the same time) do nothing
		rss_data = rss_function
	end --# if if (updates_function ~= nil) and (updates_function ~= "") and (type(updates_function) == "table") then
	--#### anidDB Watched Shows Feed ###
	blx = 2
	bly = bly + 12
	if rss_data[1][1] > -1 then
		cr = draw_shaded_text(cr, rss_data[1][#rss_data[1]][2], blx, bly, rss_data[1][#rss_data[1]][3], rss_data[1][#rss_data[1]][4])
		cairo_text_extents(cr, rss_data[1][#rss_data[1]][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[1][2], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[1][2], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[1][3], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[1][3], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[1][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[1][4], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '/', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + slash_x_advance
		cr = draw_shaded_text(cr, rss_data[1][5], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[1][5], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '/', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + slash_x_advance
		cr = draw_shaded_text(cr, rss_data[1][6], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[1][6], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		for i = 7, (#rss_data[1] - 1) do
			if i == (#rss_data[1] - 1) then
				cr = draw_shaded_text(cr, rss_data[1][i], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
			else
				cr = draw_shaded_text(cr, rss_data[1][i], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
				cairo_text_extents(cr, rss_data[1][i], extents)
				blx = blx + extents.x_advance
				cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
				blx = blx + dash_x_advance
			end --# if i == #rss_data[1] then
		end --# for i = 7, #rss_data[1] do
	else
		if rss_data[1][1] <= -2 then
			cr = draw_shaded_text(cr, rss_data[1][2], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
			cairo_text_extents(cr, rss_data[1][2], extents)
			blx = blx + extents.x_advance
			cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
			blx = blx + dash_x_advance
			cr = draw_shaded_text(cr, rss_data[1][3], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		else
			cr = draw_shaded_text(cr, rss_data[1][2], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		end --# if rss_data[1][1] == -2 then
	end --# if rss_data[1][1] > -1 then
	blx = 2
	bly = bly + 12
	cairo_xlib_surface_set_size(cs, 883, conky_window.height)
	--### nyaatorrents lossless music RSS Feed ###
	if #rss_data[2] > 2 then
		cr = draw_shaded_text(cr, rss_data[2][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[2][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, ' -', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[2][3], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, rss_data[2][2][2], blx, bly, rss_data[2][2][3], rss_data[2][2][4])
		cairo_text_extents(cr, rss_data[2][2][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[2][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[2] > 2 then
	--##### End Anime RSS Feeds #####
	--#################################################
	cairo_select_font_face (cr, font, CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL)
	--############################################
	cairo_xlib_surface_set_size(cs, 888, conky_window.height)
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	cairo_xlib_surface_set_size(cs, 877, conky_window.height)
	blx = 2
	bly = bly + 12
	if #rss_data[3] > 3 then
		cr = draw_shaded_text(cr, "1.9.1", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "1.9.1", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[3][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[3][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, ' -', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[3][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "1.9.1", blx, bly, rss_data[3][3][3], rss_data[3][3][4])
		cairo_text_extents(cr, "1.9.1", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[3][3][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[3][3][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[3][3][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[3][3][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[3][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[3] > 3 then
	--############################################
	cairo_xlib_surface_set_size(cs, 869, conky_window.height)
	blx = 2
	bly = bly + 12
	if #rss_data[4] > 3 then
		cr = draw_shaded_text(cr, "Master", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[4][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[4][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[4][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "Master", blx, bly, rss_data[4][3][3], rss_data[4][3][4])
		cairo_text_extents(cr, "Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[4][3][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[4][3][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[4][3][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[4][3][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[4][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[4] > 3 then
	--############################################
	cairo_xlib_surface_set_size(cs, 861, conky_window.height)
	blx = 2
	bly = bly + 12
	if #rss_data[5] > 3 then
		cr = draw_shaded_text(cr, "Lua Config", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "Lua Config", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[5][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[5][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[5][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "Lua Config", blx, bly, rss_data[5][3][3], rss_data[5][3][4])
		cairo_text_extents(cr, "Lua Config", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[5][3][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[5][3][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[5][3][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[5][3][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[5][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[5] > 3 then
	--############################################
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	cairo_xlib_surface_set_size(cs, 853, conky_window.height)
	blx = 2
	bly = bly + 12
	if #rss_data[8] > 2 then
		cr = draw_shaded_text(cr, "spacefm Next", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "spacefm Next", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[8][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[8][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[8][3], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "spacefm Next", blx, bly, rss_data[8][2][3], rss_data[8][2][4])
		cairo_text_extents(cr, "spacefm Next", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[8][2][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[8][2][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[8][2][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[8][2][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[8][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[8] > 2 then
	--############################################
	blx = 2
	bly = bly + 12
	if #rss_data[9] > 2 then
		cr = draw_shaded_text(cr, "udevil Next", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "udevil Next", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[9][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[9][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[9][3], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "udevil Next", blx, bly, rss_data[9][2][3], rss_data[9][2][4])
		cairo_text_extents(cr, "udevil Next", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[9][2][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[9][2][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[9][2][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[9][2][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[9][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[9] > 2 then
	--############################################
	cairo_xlib_surface_set_size(cs, 855, conky_window.height)
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	cairo_xlib_surface_set_size(cs, 853, conky_window.height)
	blx = 2
	bly = bly + 12
	if #rss_data[10] > 3 then
		cr = draw_shaded_text(cr, "mplayer2 Master", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "mplayer2 Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[10][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[10][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[10][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "mplayer2 Master", blx, bly, rss_data[10][3][3], rss_data[10][3][4])
		cairo_text_extents(cr, "mplayer2 Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[10][3][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[10][3][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[10][3][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[10][3][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[10][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[10] > 3 then
	--############################################
	blx = 2
	bly = bly + 12
	if #rss_data[11] > 2 then
		cr = draw_shaded_text(cr, "mplayer2 Build", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "mplayer2 Build", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[11][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[11][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[11][3], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "mplayer2 Build", blx, bly, rss_data[11][2][3], rss_data[11][2][4])
		cairo_text_extents(cr, "mplayer2 Build", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[11][2][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[11][2][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[11][2][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[11][2][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[11][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[11] > 2 then
	--############################################
	blx = 2
	bly = bly + 12
	if #rss_data[12] > 3 then
		cr = draw_shaded_text(cr, "smplayer2 Master", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "smplayer2 Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[12][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[12][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[12][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "smplayer2 Master", blx, bly, rss_data[12][3][3], rss_data[12][3][4])
		cairo_text_extents(cr, "smplayer2 Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[12][3][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[12][3][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[12][3][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[12][3][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[12][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[12] > 3 then
	--############################################
	cairo_xlib_surface_set_size(cs, 860, conky_window.height)
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	cairo_xlib_surface_set_size(cs, 860, conky_window.height)
	blx = 2
	bly = bly + 12
	if #rss_data[6] > 2 then
		cr = draw_shaded_text(cr, "Fluxbox Master", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "Fluxbox Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[6][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[6][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[6][3], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "Fluxbox Master", blx, bly, rss_data[6][2][3], rss_data[6][2][4])
		cairo_text_extents(cr, "Fluxbox Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[6][2][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[6][2][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[6][2][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[6][2][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[6][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[6] > 2 then
	--############################################
	cairo_xlib_surface_set_size(cs, 867, conky_window.height)
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	cairo_xlib_surface_set_size(cs, 869, conky_window.height)
	blx = 2
	bly = bly + 12
	if #rss_data[14] > 3 then
		cr = draw_shaded_text(cr, "dunst Master", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "dunst Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[14][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[14][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[14][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "dunst Master", blx, bly, rss_data[14][3][3], rss_data[14][3][4])
		cairo_text_extents(cr, "dunst Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[14][3][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[14][3][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[14][3][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[14][3][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[14][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[14] > 3 then
	--############################################
	cairo_xlib_surface_set_size(cs, 879, conky_window.height)
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	cairo_xlib_surface_set_size(cs, 885, conky_window.height)
	blx = 2
	bly = bly + 12
	if #rss_data[7] > 3 then
		cr = draw_shaded_text(cr, "Hugin", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "Hugin", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[7][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[7][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[7][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "Hugin", blx, bly, rss_data[7][3][3], rss_data[7][3][4])
		cairo_text_extents(cr, "Hugin", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[7][3][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[7][3][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[7][3][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[7][3][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[7][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[7] > 3 then
	--############################################
	cairo_xlib_surface_set_size(cs, 897, conky_window.height)
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	cairo_xlib_surface_set_size(cs, 909, conky_window.height)
	blx = 2
	bly = bly + 12
	if #rss_data[13] > 3 then
		cr = draw_shaded_text(cr, "deadbeef Master", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "deadbeef Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[13][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[13][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[13][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "deadbeef Master", blx, bly, rss_data[13][3][3], rss_data[13][3][4])
		cairo_text_extents(cr, "deadbeef Master", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[13][3][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[13][3][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[13][3][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[13][3][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[13][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[13] > 3 then
	--############################################
	cairo_xlib_surface_set_size(cs, 929, conky_window.height)
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	cairo_xlib_surface_set_size(cs, conky_window.width, conky_window.height)
	blx = 2
	bly = bly + 12
	if #rss_data[15] > 3 then
		cr = draw_shaded_text(cr, "octave", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "octave", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[15][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[15][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[15][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "octave", blx, bly, rss_data[15][3][3], rss_data[15][3][4])
		cairo_text_extents(cr, "octave", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[15][3][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[15][3][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[15][3][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[15][3][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[15][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[15] > 3 then
	--############################################
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	blx = 2
	bly = bly + 12
	if #rss_data[16] > 3 then
		cr = draw_shaded_text(cr, "kvirc SVN", blx, bly, {color6_R,color6_G,color6_B,color6_A}, {0,0,0,1})
		cairo_text_extents(cr, "kvirc SVN", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[16][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[16][1], extents)
		blx = blx + extents.x_advance
		cr = draw_shaded_text(cr, '-', blx, bly, {color0_R,color0_G,color0_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + dash_x_advance
		cr = draw_shaded_text(cr, rss_data[16][4], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	else
		cr = draw_shaded_text(cr, "kvirc SVN", blx, bly, rss_data[16][3][3], rss_data[16][3][4])
		cairo_text_extents(cr, "kvirc SVN", extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[16][3][1], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[16][3][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[16][3][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		cairo_text_extents(cr, rss_data[16][3][2], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[16][1], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	end --# if #rss_data[16] > 3 then
	--############################################
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	local bly1 = bly
	local blx1 = 2
	cairo_xlib_surface_set_size(cs, 529, conky_window.height)
	for i = 1, #rss_data[17] do
		blx = blx1
		bly = bly + 12
		cr = draw_shaded_text(cr, rss_data[17][i][1], blx, bly, rss_data[17][i][5][2], rss_data[17][i][5][3])
		cairo_text_extents(cr, rss_data[17][i][1], extents)
		blx = blx + extents.x_advance + 1
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		if rss_data[17][i][2] ~= "" then --# this is not on the page if you have read up to the latest chapter
			cr = draw_shaded_text(cr, rss_data[17][i][2], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
			cairo_text_extents(cr, rss_data[17][i][2], extents)
			blx = blx + extents.x_advance + 1
			cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
			blx = blx + vBar_x_advance
		end --# if rss_data[17][i][2] ~= "" then
		for j = 1, #rss_data[17][i][6] do
			cr = draw_shaded_text(cr, rss_data[17][i][6][j], blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
			cairo_text_extents(cr, rss_data[17][i][6][j], extents)
			blx = blx + extents.x_advance + 1
			if j ~= #rss_data[17][i][6] then
				cr = draw_shaded_text(cr, "|", blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
				blx = blx + vBar_x_advance
			else
				cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
				blx = blx + vBar_x_advance
			end
		end --# for j = 1, #rss_data[17][i][6] do
		if tonumber(rss_data[17][i][7]) < 2 then
			cr = draw_shaded_text(cr, "c."..rss_data[17][i][8], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
			cairo_text_extents(cr, "c."..rss_data[17][i][8], extents)
			blx = blx + extents.x_advance + 1
		else
			cr = draw_shaded_text(cr, "v."..rss_data[17][i][7], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
			cairo_text_extents(cr, "v."..rss_data[17][i][7], extents)
			blx = blx + extents.x_advance + 3
			cr = draw_shaded_text(cr, "c."..rss_data[17][i][8], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
			cairo_text_extents(cr, "c."..rss_data[17][i][8], extents)
			blx = blx + extents.x_advance + 1
		end --# if tonumber(rss_data[17][i][7]) < 2 then
		cr = draw_shaded_text(cr, "|", blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
		blx = blx + vBar_x_advance
		cr = draw_shaded_text(cr, rss_data[17][i][4], blx, bly, {color4_R,color4_G,color4_B,color0_A}, {color3_R,color3_G,color3_B,color3_A})
		if ((math.mod(i, (#rss_data[17]/2)) == 0) and (i ~= #rss_data[17])) then
			cr = draw_horizontal_divider(cr,528, (bly1 - 1), 528, (bly + 4), 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
			cairo_xlib_surface_set_size(cs, conky_window.width, conky_window.height)
			if (math.mod(i, #rss_data[17]) == 0) then
				blx1 = 2
				bly = bly + 5
				cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
				bly1 = bly
			else
				blx1 = 530
				bly = bly1
			end --# if (math.mod(i, #rss_data[17]) == 0) then
		end --# if ((math.mod(i, (#rss_data[17]/2)) == 0) and (i ~= #rss_data[17])) then
	end --# for i = 1, # rss_data[17] do
	--############################################
	bly = bly + 5
	cr = draw_horizontal_divider(cr,1, bly, conky_window.width, bly, 1, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	blx = 701
	bly = bly + 12
	local conky_pid_cmd = io.popen("pgrep -f -x \"conky -c .*/conkyrc_rss\"")
	local conky_pid = (conky_pid_cmd:read("*a")):gsub("\n","")
	conky_pid_cmd:close()
	conky_pid_cmd = nil
	local conky_mem_res = (conky_parse("${pid_vmrss "..conky_pid.."}")):gsub(" kB","")
	conky_mem_res = tonumber(conky_mem_res)
	if conky_mem_res_min == nil then
		conky_mem_res_min = conky_mem_res
	elseif conky_mem_res < conky_mem_res_min then
		conky_mem_res_min = conky_mem_res
	end
	local lua_mem_used = collectgarbage ("count")
	if lua_mem_used_min == nil then
		lua_mem_used_min = lua_mem_used
	elseif lua_mem_used < lua_mem_used_min then
		lua_mem_used_min = lua_mem_used
	end
	local conky_mem_line = "conky_rss "..conky_pid.." "..conky_mem_res.."kB "..string.format("%.2f",lua_mem_used).." "..conky_mem_res_min.."kB "..string.format("%.2f",lua_mem_used_min)
	cr = draw_shaded_text(cr, conky_mem_line, blx, bly, {color1_R,color1_G,color1_B,color1_A}, {color3_R,color3_G,color3_B,color3_A})
	--############################################
	cairo_destroy(cr)
	cairo_surface_destroy(cs)
	cr = nil
	cs = nil
	local gcollect = collectgarbage ("collect")
end-- end main function

function draw_shaded_text(CR, text, xpos, ypos, COLOR, shade_color)
	cairo_set_source_rgba (CR,shade_color[1],shade_color[2],shade_color[3],shade_color[4]) --# set shade color
	cairo_move_to (CR,(xpos + 1),(ypos + 1))
	cairo_show_text (CR,text)
	cairo_stroke (CR)
	cairo_set_source_rgba (CR,COLOR[1],COLOR[2],COLOR[3],COLOR[4]) --# set font color
	cairo_move_to (CR,xpos,ypos)
	cairo_show_text (CR,text)
	cairo_stroke (CR)
	return CR
end --# function cr = cr = draw_shaded_text(cr, cr, )

function draw_horizontal_divider(CR, xpos, ypos, xend, yend, lineWidth, COLOR, shade_color)
	--cairo_set_antialias (cr, CAIRO_ANTIALIAS_NONE) --# don't antialias outline it is too thin and gets blurred
	cairo_set_line_width (CR,lineWidth)
	--# draw shade
	cairo_set_source_rgba (CR,shade_color[1],shade_color[2],shade_color[3],shade_color[4]) --# set shade color
	cairo_move_to (CR, (xpos + 1), (ypos + 1))
	cairo_line_to (CR,(xend + 1), (yend + 1))
	cairo_stroke (CR)
	--# draw line
	cairo_set_source_rgba (CR,COLOR[1],COLOR[2],COLOR[3],COLOR[4]) --# set color
	cairo_move_to (CR, xpos, ypos)
	cairo_line_to (CR, xend, yend)
	cairo_stroke (CR)
	--cairo_set_antialias (cr, CAIRO_ANTIALIAS_DEFAULT)
	return CR
end --# function cr = cr = draw_horizontal_divider(cr,cr, )

function draw_bg(CR,bgColor)
	-- "corner_r" is the radius, in pixels, of the rounded corners. If you don't want rounded corners, use 0.
	local corner_r = 0
	local v = 0
	--######
	local w = conky_window.width
	local h = conky_window.height
	cairo_move_to(CR,corner_r,0)
	cairo_line_to(CR,w-corner_r,0)
	cairo_curve_to(CR,w,0,w,0,w,corner_r)
	cairo_line_to(CR,w,h+v-corner_r)
	cairo_curve_to(CR,w,h+v,w,h+v,w-corner_r,h+v)
	cairo_line_to(CR,corner_r,h+v)
	cairo_curve_to(CR,0,h+v,0,h+v,0,h+v-corner_r)
	cairo_line_to(CR,0,corner_r)
	cairo_curve_to(CR,0,0,0,0,corner_r,0)
	cairo_close_path(CR)
	cairo_set_source_rgba(CR,bgColor[1],bgColor[2],bgColor[3],bgColor[4])
	cairo_fill(CR)
	return CR
end --# function draw_bg()

--#### cups_and_saucers clock functions ##########################################################################
--#### modifed version of Revolutionary Clock ( Conky ) by abuyahya
--#### http://gnome-look.org/content/show.php/Revolutionary+Clock+%28+Conky+%29?content=151215
--------------------------------------------------------------------------------
----Adjustable Settings -- cup sector angle adjusts step size
table_setting = {
    {
    name='time2',                   arg='%H.%M',                    max_value=24,
    x=xCenter,                         y=yCenter,
    cup_radius=35,
    cup_wall_thickness=90,
    cup_sector_angle=15,           cup_sector_circ=10,
    cup_bg_clr=0xffffff,           cup_bg_alpha=0.0,
    cup_fg_clr=0xFFFFFF,           cup_fg_alpha=0.0,
    handle_length=70,              handle_circ=1,
    handle_fg_clr=0xFFFFFF,        handle_fg_alpha=0.0,
    graduation_radius=-60+124,
    graduation_thickness=8,        graduation_mark_circ=1.5,
    graduation_mark_angle=30,
    graduation_fg_clr=0xCC9900,    graduation_fg_alpha=0.0,
    saucer_thickness=6,            thick_saucer_circ=11/12,    
    saucer_radius=-60+135,         thin_saucer_circ=11/12,    
    saucer_fg_clr=0xCC9900,        saucer_fg_alpha=0.7, 
    saucer_mark_fg_clr=0xCC9900,   saucer_mark_fg_alpha=1.0,
    inner_saucer=true,             thin_saucer_fg_alpha=0.9,
    txt_weight=0,                  txt_size=0,
    txt_fg_clr=0xFFFFFF,           txt_fg_alpha=1.0,
    caption='',                    caption2='',
    },
    {
    name='time2',                   arg='%M.%S',                    max_value=60,
    x=xCenter,                         y=yCenter,
    cup_radius=55,
    cup_wall_thickness=120,
    cup_sector_angle=6,            cup_sector_circ=3,
    cup_bg_clr=0xffffff,           cup_bg_alpha=0.0,
    cup_fg_clr=0xFFFFFF,           cup_fg_alpha=0.0,
    graduation_radius=-60+123,
    graduation_thickness=10,       graduation_mark_circ=2.5,
    graduation_mark_angle=90,
    graduation_fg_clr=0xCC9900,    graduation_fg_alpha=0.0,
    handle_length=110,             handle_circ=1,
    handle_fg_clr=0xCC9900,        handle_fg_alpha=0.0,
    saucer_thickness=6,            thick_saucer_circ=11/12,
    saucer_radius=-60+155,         thin_saucer_circ=11/12,    
    saucer_fg_clr=0xCC9900,        saucer_fg_alpha=0.7,
    saucer_mark_fg_clr=0xCC9900,   saucer_mark_fg_alpha=1.0,
    inner_saucer=true,             thin_saucer_fg_alpha=0.9,
    txt_weight=0,                  txt_size=8.0,
    txt_fg_clr=0xFFFFFF,           txt_fg_alpha=0.0,
    caption='',                    caption2='',
    },
    {
    name='time',                   arg='%S',                    max_value=60,
    x=xCenter,                         y=yCenter,
    cup_radius=59,
    cup_wall_thickness=120,
    cup_sector_angle=6,            cup_sector_circ=3,
    cup_bg_clr=0xffffff,           cup_bg_alpha=0.0,
    cup_fg_clr=0xFFFFFF,             cup_fg_alpha=0.0,
    handle_fg_clr=0xFFFFFF,        handle_fg_alpha=0.0,
    handle_length=118,             handle_circ=1,
    graduation_radius=-60+125,
    graduation_thickness=6,        graduation_mark_circ=0.5,
    graduation_mark_angle=6,
    graduation_fg_clr=0xEE7600,    graduation_fg_alpha=0.0,
    saucer_thickness=5,            thick_saucer_circ=1,
    saucer_radius=-60+145,         thin_saucer_circ=11/12,    
    saucer_fg_clr=0xEE7600,        saucer_fg_alpha=0.7,
    saucer_mark_fg_clr=0xEE7600,   saucer_mark_fg_alpha=1.0,
    inner_saucer=true,             thin_saucer_fg_alpha=0.9,
    txt_weight=0,                  txt_size=8.0,
    txt_fg_clr=0xEE7600,           txt_fg_alpha=0.0,
    caption='',                    caption2='',
},
}
  
--Fixed code -do not edit unless you know what you are doing------------------------------------------------------------------------
-------------------------------------------------------------------------------
-- converts color in hexa to decimal
function rgb_to_r_g_b(clr, alpha)
    return ((clr / 0x10000) % 0x100) / 255., ((clr / 0x100) % 0x100) / 255., (clr % 0x100) / 255., alpha
end
-------------------------------------------------------------------------------
-- convert degree to rad and rotate (0 degree is top/north)
function angle_to_position(start_angle, current_angle)  
  local pos = current_angle + start_angle
    return ( ( pos * (2 * math.pi / 360) ) - (math.pi / 2) )
end
-------------------------------------------------------------------------------
------------------------------------------------------------------------
-- displays cups and saucers
function draw_table_setting_ring(display, data, value)
    local max_value = data['max_value']
    local x, y = data['x'], data['y']
    local cup_radius = data['cup_radius']    
    local cup_wall_thickness, cup_sector_circ = data['cup_wall_thickness'], data['cup_sector_circ']
    local handle_length, handle_circ = data['handle_length'], data['handle_circ']
    local cup_start_angle = data['cup_start_angle']
    if cup_start_angle == nil then cup_start_angle =0 end
    local cup_sector_angle = data['cup_sector_angle']
    local cup_bg_clr, cup_bg_alpha = data['cup_bg_clr'], data['cup_bg_alpha']
    local cup_fg_clr, cup_fg_alpha = data['cup_fg_clr'], data['cup_fg_alpha']
    local handle_fg_clr, handle_fg_alpha = data['handle_fg_clr'], data['handle_fg_alpha']
    local cup_end_angle = (max_value * cup_sector_angle) + cup_start_angle
    if cup_end_angle > 360 then  cup_end_angle = cup_end_angle - 360 end
-- cup centre background
    cairo_arc(display, x, y, cup_radius, angle_to_position(cup_start_angle, 0), angle_to_position(cup_start_angle, cup_end_angle))
    cairo_set_source_rgba(display, rgb_to_r_g_b(cup_bg_clr, cup_bg_alpha))
    cairo_set_line_width(display, cup_wall_thickness)
    cairo_stroke(display)    
    local val = (value % (max_value))
    local start_arc = 0
    local stop_arc = 0
    local i = 1
    while i <= val do
        start_arc = (cup_sector_angle * i) - (cup_sector_circ*0.5)
        stop_arc = (cup_sector_angle * i) + (cup_sector_circ*0.5)
        cairo_arc(display, x, y, cup_radius, angle_to_position(cup_start_angle, start_arc), angle_to_position(cup_start_angle, stop_arc))
        cairo_set_source_rgba(display, rgb_to_r_g_b(cup_fg_clr, cup_fg_alpha))
        cairo_stroke(display)
        i = i + 1
    end  
-- cup handle
    local start_handle = (cup_sector_angle * value) - (handle_circ*0.5)
    local stop_handle = (cup_sector_angle * value) +  (handle_circ*0.5)
    cairo_arc(display, x, y, cup_radius, angle_to_position(cup_start_angle, start_handle), angle_to_position(cup_start_angle, stop_handle))
    cairo_set_line_width(display, handle_length)    
    cairo_set_source_rgba(display, rgb_to_r_g_b(handle_fg_clr, handle_fg_alpha))
    cairo_stroke(display)
--saucers
    local saucer_thickness = data['saucer_thickness']
    local saucer_fg_clr = data['saucer_fg_clr']
    local saucer_fg_alpha = data['saucer_fg_alpha']
    local thin_saucer_fg_alpha = data['thin_saucer_fg_alpha']
    local saucer_radius = data['saucer_radius']
    local saucer_mark_fg_alpha = data['saucer_mark_fg_alpha']
    local saucer_mark_fg_clr = data['saucer_mark_fg_clr']
    local thick_saucer_circ = data['thick_saucer_circ']
    local thin_saucer_circ = data['thin_saucer_circ']
    local inner_saucer = data['inner_saucer']
--# saucer
    if saucer_fg_alpha > 0 and (thin_saucer_circ >0 or thick_saucer_circ > 0) then
		if i < (max_value/2) 
			then j = value + (max_value/2)
			else j = value - (max_value/2)
		end --# if i < (max_value/2)
		--thin saucer
		if inner_saucer == true then 
			rt = (saucer_radius - 0.5) + (0.5 * saucer_thickness)
		else 
			rt = (saucer_radius + 0.5) - (0.5 * saucer_thickness)  
		end --# if inner_saucer == true then 
		local start_thin_saucer = (cup_sector_angle * j) - (max_value *0.5*cup_sector_angle*thin_saucer_circ)
		local stop_thin_saucer = (cup_sector_angle * j) + (max_value *0.5*cup_sector_angle*thin_saucer_circ)
		cairo_arc(display, x, y, rt, angle_to_position(cup_start_angle, start_thin_saucer), angle_to_position(cup_start_angle, stop_thin_saucer))
		cairo_set_source_rgba(display, rgb_to_r_g_b(saucer_fg_clr, thin_saucer_fg_alpha))
		cairo_set_line_width(display, 1)
		cairo_stroke(display)
		---thick saucer
		local start_saucer = (cup_sector_angle * j) - (value*cup_sector_angle*0.5*thick_saucer_circ)
		local stop_saucer = (cup_sector_angle * j) + (value*cup_sector_angle*0.5*thick_saucer_circ)
		cairo_arc(display, x, y, saucer_radius, angle_to_position(cup_start_angle, start_saucer), angle_to_position(cup_start_angle, stop_saucer))
		cairo_set_source_rgba(display, rgb_to_r_g_b(saucer_fg_clr, saucer_fg_alpha))
		cairo_set_line_width(display, saucer_thickness)
		cairo_stroke(display)
    end --# if saucer_fg_alpha > 0 and (thin_saucer_circ >0 or thick_saucer_circ > 0) then 
--saucer mark
    if saucer_mark_fg_alpha > 0
       then 
	local start_cm = (cup_sector_angle * value) - (handle_circ *0.5 )
	local stop_cm = (cup_sector_angle * value) + (handle_circ *0.5 )
	cairo_arc(display, x, y, saucer_radius, angle_to_position(cup_start_angle, start_cm), angle_to_position(cup_start_angle, stop_cm))
	cairo_set_source_rgba(display, rgb_to_r_g_b(saucer_mark_fg_clr, saucer_mark_fg_alpha))
        cairo_set_line_width(display, saucer_thickness)
        cairo_stroke(display)
      end 
      
--graduation mark
    local graduation_radius = data['graduation_radius']
    local graduation_thickness, graduation_mark_circ = data['graduation_thickness'], data['graduation_mark_circ']
    local graduation_mark_angle = data['graduation_mark_angle']
    local graduation_fg_clr, graduation_fg_alpha = data['graduation_fg_clr'], data['graduation_fg_alpha']
    if graduation_radius > 0 and graduation_thickness > 0 and graduation_mark_angle > 0 then
       if cup_start_angle < cup_end_angle 
         then number_graduation = (cup_end_angle-cup_start_angle) / graduation_mark_angle
         else number_graduation = (cup_end_angle+(360-cup_start_angle)) / graduation_mark_angle
       end
       local i = 0
        while i < number_graduation do
            cairo_set_line_width(display, graduation_thickness)
            local start_arc_grad = (graduation_mark_angle * (i-1)) - (graduation_mark_circ *0.5)
            local stop_arc_grad = (graduation_mark_angle * (i-1)) + (graduation_mark_circ *0.5)
            cairo_arc(display, x, y, graduation_radius, angle_to_position(cup_start_angle, start_arc_grad), angle_to_position(cup_start_angle, stop_arc_grad))
            cairo_set_source_rgba(display,rgb_to_r_g_b(graduation_fg_clr,graduation_fg_alpha))
            cairo_stroke(display)
            cairo_set_line_width(display, cup_wall_thickness)
            i = i + 1
        end
    end
-- text
    local txt_fg_clr, txt_fg_alpha = data['txt_fg_clr'], data['txt_fg_alpha']
    local txt_weight, txt_size = data['txt_weight'], data['txt_size']
    local txt_fg_clr, txt_fg_alpha = data['txt_fg_clr'], data['txt_fg_alpha']
    local caption = data['caption']
    local caption2 = data['caption2']
    if inner_saucer == true
    then
      ytxt=-(txt_size*0.5)
      else ytxt =(txt_size)
    end
    cairo_select_font_face (display, "hooge 05_53", CAIRO_FONT_SLANT_NORMAL, txt_weight);
    cairo_set_font_size (display,txt_size)
    cairo_set_source_rgba (display, rgb_to_r_g_b(txt_fg_clr, txt_fg_alpha))
    cairo_move_to (display,x-(saucer_radius*0.7),(y+ytxt))
    cairo_show_text (display, caption ) cairo_show_text (display,value)cairo_show_text (display, caption2 )
    cairo_stroke (display)
end
-------------------------------------------------------------------------------
-- loads data and displays table_settings
function display_table_settings(display)
    local function load_table_settings(display, data)
        local str, value = '', 0
        if data['name'] == 'time2' then
			str = string.format('${time %s}', data['arg'])
			str = conky_parse(str)
			value = tonumber(str:sub(0,2)) + (tonumber(str:sub(4,5))/60)
			--print(value)
		else
			str = string.format('${%s %s}',data['name'], data['arg'])
			str = conky_parse(str)
			value = tonumber(str)
        end --if data['name'] == 'time2' then
	if value == nil then value = 0 end
        draw_table_setting_ring(display, data, value)
    end

    for i in pairs(table_setting) do
        load_table_settings(display, table_setting[i])
    end
end
-------------------------------------------------------------------------------

--#########
function draw_bg_clock(CR, bgColor)
	cairo_move_to(CR,xCenter,yCenter)
	cairo_arc(CR,xCenter,yCenter,98,0,(2*math.pi))
	cairo_close_path(CR)
	cairo_set_source_rgba(CR,bgColor[1],bgColor[2],bgColor[3],bgColor[4])
	cairo_fill(CR)
	return CR
end --# function draw_bg()
