#!/usr/bin/env python2.7
# -*- coding: utf-8 -*-
'''
Name:  conky_unifiedRSS_CB10_lua_2.py
Author: arclance
Date_Created:2012-07-11
Date_Updated:2012-08-13

Check multiple rss feeds from one script and format for display in conky using a lua script
monitor reading list on mangaupdates.com and format for dispaly in conky

#####################################################################################
Changelog
v1.7 - 2012-08-13
	figured out mechanize don't need twill anymore
	
v1.6.2 - 2012-08-13
	specify mangaudates.com username and password at the commandline

v1.6.1 - 2012-08-11
	try to catch connection errors from mangaupdates section to prevent crashes

v1.6 - 2012-07-25
	fix finding sortedEntry[2] if no group name (raws, etc) 
		check for file sizes unit in string to differentiate between episode titles and file size strings
	
v1.5 - 2012-07-24
	add mangaupdates mylist data
	
v1.4 - 2012-07-22
	fix [] charachters in full text section.

v1.3 - 2012-07-20
	fix detection of missing file type from "fileGroup_Type" by striping "..." out (truncated strings screwed up detection)

v1.2 - 2012-07-17
	anidb feed
		fixed finding episode title for truncated title entries when the cuttoff falls in the filesize section of the string
		fixed typo in conkyOuput grouping (forgot a ())

v1.1.1 - 2012-07-15
	added deadbeef, dunst, and octave rss feeds

v1.1 - 2012-07-14
	add timestamps to output
	output color settings based on age of each rss feed entry
	added conky, fluxbox, hugin, spacefm, udevil, mplayer2, and smplayer2 rss feeds
	
####################################################################################
Requries
	python2.7
		requred modules
			dateutil
			mechanize
			feedparser
			urllib2
			cookielib
			httplib
			socket
			time
			calendar
			sys
			
		packages in debian
			python2.7
			python-dateutil
			python-mechanize
			python-feedparser
			
#####################################################################################
'''

import urllib2
import httplib
import socket
import feedparser
import time
from dateutil import parser
from calendar import timegm
#####
import mechanize
import cookielib
from sys import argv
#####
# call this way
# python conky_unifiedRSS_CB10_lua.py mangaupdates_username mangaupdates_password
# escape sepcial characters (!,#,etc.) with \
#####
logDirectory = "" # directory output file goes in
aniDB_RSS_URL = "" # personal anidb rss feed
nyaaMusic_RSS_URL = "http://www.nyaa.eu/?page=rss&cats=3_14"
conkyGit191_RSS_URL = "http://git.omp.am/?p=conky.git;a=atom;h=refs/heads/1.9.1"
conkyGitMaster_RSS_URL = "http://git.omp.am/?p=conky.git;a=atom;h=refs/heads/master"
conkyGitLuaConfig_RSS_URL = "http://git.omp.am/?p=conky.git;a=atom;h=refs/heads/lua-config"
fluxboxMaster_RSS_URL = "http://git.fluxbox.org/fluxbox.git/atom/?h=master"
huginMercurial_RSS_URL = "http://hugin.hg.sourceforge.net/hgweb/hugin/hugin/atom-log"
spacefmNext_RSS_URL = "https://github.com/IgnorantGuru/spacefm/commits/next.atom"
udevilNext_RSS_URL = "https://github.com/IgnorantGuru/udevil/commits/next.atom"
mplayer2Master_RSS_URL = "http://git.mplayer2.org/mplayer2/atom/?h=master"
mplayer2Build_RSS_URL = "http://git.mplayer2.org/mplayer2-build/atom/?h=master"
smplayer2Master_RSS_URL = "https://github.com/lachs0r/SMPlayer2/commits/master.atom"
deadbeefMaster_RSS_URL = "http://deadbeef.git.sourceforge.net/git/gitweb.cgi?p=deadbeef/deadbeef;a=atom;h=refs/heads/master"
dunstMaster_RSS_URL = "https://github.com/knopwob/dunst/commits/master.atom"
octaveMercurial_RSS_URL = "http://hg.savannah.gnu.org/hgweb/octave/atom-log"
kvircSVN_RSS_URL = "https://svn.kvirc.de/kvirc/timeline?ticket=on&changeset=on&milestone=on&max=5&daysback=30&format=rss"
#####

def tryconnect(turl, timer=4, retries=3):
	for tried in xrange(retries):
		try:
			return [urllib2.urlopen(turl, None, timer), ""]
		except (urllib2.URLError, socket.timeout, httplib.BadStatusLine), e:
			print "tryconnect Error: " + str(e)
		else:
			print "tryconnect: break"
			break
		#endtry
	#endfor
	return [None, str(e)]
#enddef

def openURL(request_url, timer=30, retries=3):
	[urlopener, urlopener_error] = tryconnect(request_url, timer, retries)
	if urlopener:
		try:
			return [urlopener, urlopener_error]
		except (httplib.IncompleteRead, httplib.BadStatusLine, socket.timeout), e:
			print "openURL Error: " + str(e)
			return [None, str(e)]
		#endtry
	else:
		return [None, urlopener_error]
	#endif
#enddef

def aniDB_Check():
	print "\n##### Getting aniDB RSS Data #####"
	newestEntry_Formated = u""
	noGroupName = False
	truncatedFileString = False
	try:
		rssFeed_Parsed = feedparser.parse(aniDB_RSS_URL)
		if len(rssFeed_Parsed.entries) != 0:
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			newestEntry = rssFeed_Parsed.entries[0].title.replace("amp;","").split(" - ")
			print str(newestEntry)
			sortedEntry = [u"",u"",u""]
			lastEntry = u""
			lastEntry_Good = False
			for i in xrange(len(newestEntry)):
				if i == 0: # first entry is always the name of the series if there is a group name
					sortedEntry[0] = newestEntry[0]
				elif newestEntry[i].isnumeric() == True: ## detect episode numbers
					sortedEntry[1] = newestEntry[i]
				elif (newestEntry[i][0].isdigit() == False) and (newestEntry[i][1:len(newestEntry[i])].isnumeric() == True): ## Detect special episode numbers (E1 (ending 1), ect.)
					sortedEntry[1] = newestEntry[i]
				elif (newestEntry[i].find("...") != (-1)):
					sortedEntry[2] = newestEntry[i]
					if (newestEntry[i].find("(") == (-1)) and (newestEntry[i].find(")") == (-1)) and (newestEntry[i].find("[") == (-1)) and (newestEntry[i].find("]") == (-1)):
						lastEntry = newestEntry[i]
						lastEntry_Good = True
						print "lastEntry = " + lastEntry
					#endif
					truncatedFileString = True
				elif newestEntry[i].find("[") != (-1) and newestEntry[i].find("]") != (-1): # find group name (allways in [Group Name] Format)
					sortedEntry[2] = newestEntry[i]
				elif newestEntry[i].find("(") != (-1) and newestEntry[i].find(")") != (-1) and ((newestEntry[i].find("GB") != (-1)) or (newestEntry[i].find("MB") != (-1))): # find sortedEntry[2] if no group name (raws, etc) # 2012-07-25 | check for file sizes unit in string to differentiate between episode titles and file size strings
					sortedEntry[2] = newestEntry[i]
					noGroupName = True
				else: # append everything else to the end
					sortedEntry.append(newestEntry[i])
				#endif
			#endfor
			if lastEntry_Good == False:
				lastEntry = sortedEntry[(len(sortedEntry) - 1)]
			#endif
			print "noGroupName = " + str(noGroupName)
			print "truncatedFileString = " + str(truncatedFileString)
			print str(lastEntry_Good)
			print "lastEntry = " + lastEntry + "\n"
			print str(sortedEntry) + " | " + str(len(sortedEntry))
			print str(sortedEntry[3:len(sortedEntry)])
			fileData_Split = sortedEntry[2].split(" ")
			print str(fileData_Split) + " | " + str(len(fileData_Split))
			fileGroup_Type = fileData_Split[0].replace("...","").split(".")
			print str(fileGroup_Type) + str(len(fileGroup_Type))
			### {ParseState, SeriesName, EpisodeNumber, GroupName, FileType, FileSize, EpisodeTitle}
			### ParseState | -3 = Connection Error, -2 = Parse Error, -1 = Insufficent Data, 0 = Normal Parse, 1 = "String Cutoff Parse - Very Truncated String - Unknown Filetype - No Group In String", 2 = "String Cutoff Parse - Very Truncated String - Unknown Filetype", 3 = "String Cutoff Parse - Very Truncated String", 4 = "String Cutoff Parse", 5 = "No Group Parse"
			if (len(fileData_Split) > 2) and (noGroupName == False) and (truncatedFileString == False):
				print "Normal Parse"
				conkyOutput = (u'{%s,"%s","%s","%s","%s","%s","' % (0, sortedEntry[0].replace("[!!] ","").replace('"','\\"'), sortedEntry[1], fileGroup_Type[0].replace("[", "").replace("]",""), fileGroup_Type[1], (fileData_Split[1].strip("(") + " " + fileData_Split[2].strip(")")))) + '" , "'.join(sortedEntry[3:len(sortedEntry)]).replace('"','\\"') + '",' + newestEntry_Date + '}'
			elif (len(sortedEntry) < 4) and (len(fileGroup_Type) < 2) and (truncatedFileString == True) and (noGroupName == False):
				print "String Cutoff Parse - Very Truncated String - Unknown Filetype - No Group In String"
				fileContent = rssFeed_Parsed.entries[0].content[0].value.replace("amp;","").replace("\n","").replace("\t","").replace("</dt><dd>","|").replace("</dd>","").replace("</dl></div>","").split("<dt>")
				#print str(fileContent)
				fileSize = fileContent[3].split("|")[1].split(" (") 
				fileGroup = fileContent[8].split("|")[1].split(" (")
				conkyOutput = ((u'{%s,"%s","%s","%s","%s","%s","%s",' + newestEntry_Date + '}') % (1, sortedEntry[0].replace("[!!] ","").replace('"','\\"'), sortedEntry[1], fileGroup[0], "Unknown", fileSize[0], lastEntry.replace('"','\\"')))
				print "type1 Output Made"
			elif (len(sortedEntry) < 6) and (len(fileGroup_Type) < 3) and (truncatedFileString == True):
				print "String Cutoff Parse - Very Truncated String - Unknown Filetype"
				fileContent = rssFeed_Parsed.entries[0].content[0].value.replace("amp;","").replace("\n","").replace("\t","").replace("</dt><dd>","|").replace("</dd>","").replace("</dl></div>","").split("<dt>")
				#print str(fileContent)
				fileSize = fileContent[3].split("|")[1].split(" (") 
				fileGroup = fileContent[8].split("|")[1].split(" (")
				conkyOutput = ((u'{%s,"%s","%s","%s","%s","%s","%s",' + newestEntry_Date + '}') % (2, sortedEntry[0].replace("[!!] ","").replace('"','\\"'), sortedEntry[1], fileGroup[0], "Unknown", fileSize[0], lastEntry.replace('"','\\"')))
				print "type2 Output Made"
			elif (len(sortedEntry) < 4) and (truncatedFileString == True) and (noGroupName == False):
				print "String Cutoff Parse - Very Truncated String"
				fileContent = rssFeed_Parsed.entries[0].content[0].value.replace("amp;","").replace("\n","").replace("\t","").replace("</dt><dd>","|").replace("</dd>","").replace("</dl></div>","").split("<dt>")
				#print str(fileContent)
				fileSize = fileContent[3].split("|")[1].split(" (") 
				fileGroup = fileContent[8].split("|")[1].split(" (")
				conkyOutput = ((u'{%s,"%s","%s","%s","%s","%s","%s",' + newestEntry_Date + '}') % (3, sortedEntry[0].replace("[!!] ","").replace('"','\\"'), sortedEntry[1], fileGroup[0], fileGroup_Type[1], fileSize[0], lastEntry.replace('"','\\"')))
			elif (truncatedFileString == True) and (noGroupName == False):
				print "String Cutoff Parse"
				fileContent = rssFeed_Parsed.entries[0].content[0].value.replace("amp;","").replace("\n","").replace("\t","").replace("</dt><dd>","|").replace("</dd>","").replace("</dl></div>","").split("<dt>")
				#print str(fileContent)
				fileSize = fileContent[3].split("|")[1].split(" (") 
				fileGroup = fileContent[8].split("|")[1].split(" (")
				conkyOutput = ((u'{%s,"%s","%s","%s","%s","%s","') % (4, sortedEntry[0].replace("[!!] ","").replace('"','\\"'), sortedEntry[1], fileGroup[0], fileGroup_Type[1], fileSize[0])) + '" , "'.join(sortedEntry[3:len(sortedEntry)]).replace('"','\\"') + '",' + newestEntry_Date + '}'
			elif noGroupName == True:
				print "No Group Parse"
				fileContent = rssFeed_Parsed.entries[0].content[0].value.replace("amp;","").replace("\n","").replace("\t","").replace("</dt><dd>","|").replace("</dd>","").replace("</dl></div>","").split("<dt>")
				fileSize = fileContent[3].split("|")[1].split(" (") 
				fileGroup = fileContent[8].split("|")[1].split(" (")
				fileName_Type = sortedEntry[2].split(".") # [0] = Episode name , [1] = type.split(" (")[0]
				episodeName = fileName_Type[0]
				fileType = fileName_Type[1].split(" (")[0]
				conkyOutput = ((u'{%s,"%s","%s","%s","%s","%s","%s","') % (5, sortedEntry[0].replace("[!!] ","").replace('"','\\"'), sortedEntry[1], fileGroup[0], fileType, fileSize[0], episodeName.replace('"','\\"'))) + '" , "'.join(sortedEntry[3:len(sortedEntry)]).replace('"','\\"') + '",' + newestEntry_Date + '}'
			else:
				print "Insufficent Data"
				conkyOutput = ((u'{%s,"%s","%s","%s","%s","%s","%s"}') % (-1,"Insufficent Data","","","","",""))
			#endif
		else:
			print "Connection Error"
			print str(rssFeed_Parsed)
			try:
				errorStatus = str(rssFeed_Parsed.status)
			except Exception, e0:
				errorStatus = False
			#endtry
			try:
				errorMessage = str(rssFeed_Parsed.feed.subtitle).replace("\n"," ").replace("<h1>","").replace("</h1>","").replace("<p>","").replace("</p>","")
			except Exception, e:
				print str(e)
				errorMessage = str(rssFeed_Parsed.bozo_exception).replace("\n"," ")
			#endtry
			if errorStatus != False:
				errorMessage = errorStatus + " - " + errorMessage
			#endif
			conkyOutput = ((u'{%s,"%s","%s","%s","%s","%s","%s"}') % (-3,"Connection Error",str(errorMessage),"","","",""))
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = ((u'{%s,"%s","%s","%s","%s","%s","%s"}') % (-2,"Parse Error", str(i),"","","",""))
	#endtry
	#print conkyOutput
	return conkyOutput
#enddef

def nyaaMusic_Check():
	print "\n##### Getting nyaaMusic Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(nyaaMusic_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print  str(newestEntry_Date) + " | " + newestEntry
			conkyOutput = '{"' + newestEntry + '",' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def conkyGit_191_Check():
	print "\n##### Getting conky git 1.9.1 Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(conkyGit191_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Full = rssFeed_Parsed.entries[0].content[0].value.partition("<pre>")[2].partition("</pre><ul>")[0].strip("\n").replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"').replace("[","<|").replace("]","|>").split("\n")
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title + "\n\n" + str(newestEntry_Full)
			conkyOutput = '{"' + newestEntry_Title + '",' + str(newestEntry_Full).replace("[","{").replace("]","}").replace("<|","[").replace("|>","]").replace("'{","{").replace("}'","}").replace("'\"","'").replace("\"'","'") + ',' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def conkyGit_Master_Check():
	print "\n##### Getting conky git Master Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(conkyGitMaster_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Full = rssFeed_Parsed.entries[0].content[0].value.partition("<pre>")[2].partition("</pre><ul>")[0].strip("\n").replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"').replace("[","<|").replace("]","|>").split("\n")
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title + "\n\n" + str(newestEntry_Full)
			conkyOutput = '{"' + newestEntry_Title + '",' + str(newestEntry_Full).replace("[","{").replace("]","}").replace("<|","[").replace("|>","]").replace("'{","{").replace("}'","}").replace("'\"","'").replace("\"'","'") + ',' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def conkyGit_LuaConfig_Check():
	print "\n##### Getting conky git Lua Config Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(conkyGitLuaConfig_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Full = rssFeed_Parsed.entries[0].content[0].value.partition("<pre>")[2].partition("</pre><ul>")[0].strip("\n").replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"').replace("[","<|").replace("]","|>").split("\n")
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title + "\n\n" + str(newestEntry_Full)
			conkyOutput = '{"' + newestEntry_Title + '",' + str(newestEntry_Full).replace("[","{").replace("]","}").replace("<|","[").replace("|>","]").replace("'{","{").replace("}'","}").replace("'\"","'").replace("\"'","'") + ',' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def fluxbox_Master_Check():
	print "\n##### Getting fluxbox Master Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(fluxboxMaster_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title
			conkyOutput = '{"' + newestEntry_Title + '",' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def huginMercurial_Check():
	print "\n##### Getting Hugin Mercurial Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(huginMercurial_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Full = rssFeed_Parsed.entries[0].content[0].value.partition("<pre>")[2].partition("</pre><ul>")[0].strip("\n").replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"').replace("</pre>\n   </div>","").replace("[","<|").replace("]","|>").split("\n")
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title + "\n\n" + str(newestEntry_Full)
			conkyOutput = '{"' + newestEntry_Title + '",' + str(newestEntry_Full).replace("[","{").replace("]","}").replace("<|","[").replace("|>","]").replace("'{","{").replace("}'","}").replace("'\"","'").replace("\"'","'") + ',' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def spacfm_Next_Check():
	print "\n##### Getting spacefm Next Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(spacefmNext_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title
			conkyOutput = '{"' + newestEntry_Title + '",' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def udevil_Next_Check():
	print "\n##### Getting udevil Next Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(udevilNext_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title
			conkyOutput = '{"' + newestEntry_Title + '",' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def mplayer2_Master_Check():
	print "\n##### Getting mplayer2 Master Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(mplayer2Master_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Full = rssFeed_Parsed.entries[0].subtitle.strip("\n").replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"').replace("[","<|").replace("]","|>").split("\n")
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title + "\n\n" + str(newestEntry_Full)
			conkyOutput = '{"' + newestEntry_Title + '",' + str(newestEntry_Full).replace("[","{").replace("]","}").replace("<|","[").replace("|>","]").replace("'{","{").replace("}'","}") + ',' + newestEntry_Date + '}' # .replace("'\"","'").replace("\"'","'")
		else:
			conkyOutput = '{"Connection Error","","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def mplayer2_Build_Check():
	print "\n##### Getting mplayer2 Build Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(mplayer2Build_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title
			conkyOutput = '{"' + newestEntry_Title + '",' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def smplayer2_Master_Check():
	print "\n##### Getting smplayer2 Master Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(smplayer2Master_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Full = rssFeed_Parsed.entries[0].content[0].value.partition("<pre>")[2].partition("</pre><ul>")[0].strip("\n").replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"').replace("<pre>","").replace("</pre>","").replace("      ","").replace("[","<|").replace("]","|>").split("\n")
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title + "\n\n" + str(newestEntry_Full)
			conkyOutput = '{"' + newestEntry_Title + '",' + str(newestEntry_Full).replace("[","{").replace("]","}").replace("<|","[").replace("|>","]").replace("'{","{").replace("}'","}").replace("'\"","'").replace("\"'","'") + ',' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def deadbeef_Master_Check():
	print "\n##### Getting deadbeef Master Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(deadbeefMaster_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Full = rssFeed_Parsed.entries[0].content[0].value.partition("<pre>")[2].partition("</pre><ul>")[0].strip("\n").replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"').replace("<pre>","").replace("</pre>","").replace("      ","").replace("[","<|").replace("]","|>").split("\n")
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title + "\n\n" + str(newestEntry_Full)
			conkyOutput = '{"' + newestEntry_Title + '",' + str(newestEntry_Full).replace("[","{").replace("]","}").replace("<|","[").replace("|>","]").replace("'{","{").replace("}'","}").replace("'\"","'").replace("\"'","'") + ',' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def dunst_Master_Check():
	print "\n##### Getting dunst Master Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(dunstMaster_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Full = rssFeed_Parsed.entries[0].content[0].value.partition("<pre>")[2].partition("</pre><ul>")[0].strip("\n").replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"').replace("<pre>","").replace("</pre>","").replace("      ","").replace("[","<|").replace("]","|>").split("\n")
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title + "\n\n" + str(newestEntry_Full)
			conkyOutput = '{"' + newestEntry_Title + '",' + str(newestEntry_Full).replace("[","{").replace("]","}").replace("<|","[").replace("|>","]").replace("'{","{").replace("}'","}").replace("'\"","'").replace("\"'","'") + ',' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def octave_Mercurial_Check():
	print "\n##### Getting ocatave Mercurial Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(octaveMercurial_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Full = rssFeed_Parsed.entries[0].content[0].value.partition("<pre>")[2].partition("</pre><ul>")[0].strip("\n").replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"').replace("<pre>","").replace("</pre>","").replace("      ","").replace("[","<|").replace("]","|>").split("\n")
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title + "\n\n" + str(newestEntry_Full)
			conkyOutput = '{"' + newestEntry_Title + '",' + str(newestEntry_Full).replace("[","{").replace("]","}").replace("'{","{").replace("}'","}").replace("'\"","'").replace("\"'","'") + ',' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef

def kvirc_SVN_Check():
	print "\n##### Getting kvirc SVN Data #####"
	try:
		[rssFeed_Web, rssFeed_Error] = openURL(kvircSVN_RSS_URL)
		if rssFeed_Web:
			rssFeed_Data = rssFeed_Web.read()
			rssFeed_Web.close()
			rssFeed_Parsed = feedparser.parse(rssFeed_Data)
			newestEntry_Title = rssFeed_Parsed.entries[0].title.replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"')
			newestEntry_Full = rssFeed_Parsed.entries[0].summary.strip("\n").replace("amp;","").encode("utf-8").replace("#","\#").replace('"','\\"').replace("<p>\n","").replace("\n</p>","").replace("      ","").replace("[","<|").replace("]","|>").split("\n")
			newestEntry_Date = rssFeed_Parsed.entries[0].updated.encode("utf-8")
			newestEntry_Date = convertUTC_to_Eastern(newestEntry_Date)
			print newestEntry_Date + " | " + newestEntry_Title + "\n\n" + str(newestEntry_Full)
			conkyOutput = '{"' + newestEntry_Title + '",' + str(newestEntry_Full).replace("[","{").replace("]","}").replace("'{","{").replace("}'","}").replace("'\"","'").replace("\"'","'") + ',' + newestEntry_Date + '}'
		else:
			conkyOutput = '{"Connection Error","","","' + rssFeed_Error + '"}'
		#endif
	except Exception, i:
		print "Error: " + str(i)
		conkyOutput = '{"Parse Error","","","' + str(i) + '"}'
	#endtry
	return conkyOutput
#enddef


####### Mangaupdates.com #########
class NoHistory(object):
	def add(self, *a, **k): pass
	def clear(self): pass
	def close(self): pass
#enddef

## Setup Meachanize Browser -- Don't Keep History ###
br = mechanize.Browser(history=NoHistory())

#### Setup Cookie Handling (for login) ####
cj = cookielib.LWPCookieJar()
br.set_cookiejar(cj)

#### Add UserAgent (need for some websites) #######
br.addheaders = [('User-agent', 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0.1) Gecko/2008071615 Fedora/3.0.1-1.fc9 Firefox/3.0.1')]

###### Get Latest Read Chapter From Series Page ######
def mangaUpdates_Check(firstRun):
	print "\n##### Getting mangaupdates Data #####"
	if firstRun == True: ### only need to login when the script is first started
		#### Load Page To Login ####
		br.open('https://www.mangaupdates.com/mylist.html')
		#### Select Login Form ####
		br.select_form(nr=0)
		#### input username and password
		br.form['username'] = argv[1]
		br.form['password'] = argv[2]
		#### Login ####
		br.submit()
	#endif
	mylist = br.open('https://www.mangaupdates.com/mylist.html').read().split("\n")
	tableStart = False
	numCheck = 12 # number of entries to get data on
	numChecked = 0 # number of entries that data has been collected for
	entriesTable = [] # table to hold entries
	for i in xrange(len(mylist)):
		currentLine = mylist[i].strip()
		if currentLine.find('<table id="list_table" cellspacing="0" cellpadding="1" border="0">') != (-1):
			tableStart = True
		elif tableStart == True:
			if currentLine.find('<td class="lcol_nopri text"') != (-1):
				part0 = currentLine.partition('<a href="')
				part1 = part0[2].partition('" title="Series Info"><u>')
				part2 = part1[2].partition('</u></a>')
				part3 = part2[2].partition('stype=series">(')
				entries = [part2[0].replace("&amp;","&"), (part3[2].strip(')</a></span></td>')), part1[0]]
				######## Open Series Page ####
				print(entries[2])
				seriesPage = br.open(entries[2]).read().split("\n")
				for j in xrange(len(seriesPage)):
					currentLine = seriesPage[j].strip()
					if currentLine.find("You are reading this. (&nbsp;up to") != (-1):
						part1 = currentLine.partition('title="Increment Volume"><u><b>')
						part2 = part1[2].partition('</b></u>')
						part3 = part2[2].partition('title="Increment Chapter"><u><b>')
						part4 = part3[2].partition('</b></u>')
						readVolume = part2[0].strip('v.') # latest read volume
						readChapter = part4[0].strip('c.') # latest read chapter
					elif currentLine.find('<div class="sCat"><b>Latest Release(s)</b></div>') != (-1):
						releaseData = seriesPage[j+1].partition('<div class="sContent" >')
						part2 = releaseData[2].partition(' by ')
						part3 = part2[2].partition("title='Group Info'>")
						part5 = part3[2].partition('>(')
						part6 = part5[2].partition(' ago)')
						releaseAge = int(part6[0].strip("d"))
						releaseAge = mangaUpdates_Time(releaseAge)
						entries.append(part2[0].replace("<i>","").replace("</i>","").strip())
						entries.append(releaseAge)
						if part5[0].find("&amp; <a") != (-1): # multipleGroups
							part5_split = part5[0].split("&amp;")
							part4 = []
							for k in xrange(len(part5_split)):
								if k == 0:
									part4.append(part5_split[k].replace("</a> ",""))
								else:
									part4.append(part5_split[k].partition("title='Group Info'>")[2].partition('</a> <span style=')[0])
								#endif
							#endfor
						else:
							part4 = [part5[0].partition('</a> <span style=')[0].replace("&amp;"," & ")]
						#endif
						entries.append(part4)
						entries.append(readVolume)
						entries.append(readChapter)
						break
					#endif
				#endfor
				entriesTable.append(entries)
				numChecked += 1
				if numChecked == numCheck:
					break
				#endif
			#endif
		#endif
	#endfor
	### entries = [seriesName, latestChapter, seriesLink, releaseNumber, releaseAge, releaseGroup]
	print("#" * 20)
	return str(entriesTable).replace("[","{").replace("]","}").replace("'{","{").replace("}'","}").replace("'\"","'").replace("\"'","'")
#enddef
####### End Mangaupdates.com #########

###############################################################

def convertUTC_to_Eastern(rssTime):
	timeStruct = parser.parse(rssTime).utctimetuple()
	timeEpoch = timegm(timeStruct)
	if (timeStart - 3600) < timeEpoch:
		timeColor = "{0.64706,0,1,1}"
		shadeColor = '{0,0,0,1}'
	elif (timeStart - (3600*3)) < timeEpoch:
		timeColor = "{0,1,0,1}"
		shadeColor = '{0,0,0,1}'
	elif (timeStart - (3600*6)) < timeEpoch:
		timeColor = "{0,0.6,0,1}"
		shadeColor = '{0,0,0,1}'
	elif (timeStart - (3600*12)) < timeEpoch:
		timeColor = '{color5_R,color5_G,color5_B,1}'
		shadeColor = '{0.3,0.3,0.3,1}'
	elif (timeStart - (86400*1)) < timeEpoch:
		timeColor = '{1,0,0,1}'
		shadeColor = '{0.3,0.3,0.3,1}'
	elif (timeStart - (86400*3)) < timeEpoch:
		timeColor = '{color7_R,color7_G,color7_B,color7_A}'
		shadeColor = '{color3_R,color3_G,color3_B,color3_A}'
	elif (timeStart - (86400*7)) < timeEpoch:
		timeColor = '{color8_R,color8_G,color8_B,color8_A}'
		shadeColor = '{color3_R,color3_G,color3_B,color3_A}'
	else:
		timeColor = '{color0_R,color0_G,color0_B,color0_A}'
		shadeColor = '{color3_R,color3_G,color3_B,color3_A}'
	#endif
	return time.strftime('{"%y-%m-%d","%I:%M:%S %p",' + timeColor + ',' + shadeColor + '}',time.localtime(timeEpoch))
#enddef

def mangaUpdates_Time(releaseAge):
	if 0 == releaseAge:
		timeColor = "{0.64706,0,1,1}"
		shadeColor = '{0,0,0,1}'
	elif 1 >= releaseAge:
		timeColor = "{0,1,0,1}"
		shadeColor = '{0,0,0,1}'
	elif 2 >= releaseAge:
		timeColor = "{0,0.6,0,1}"
		shadeColor = '{0,0,0,1}'
	elif 3 >= releaseAge:
		timeColor = '{color5_R,color5_G,color5_B,1}'
		shadeColor = '{0.3,0.3,0.3,1}'
	elif 5 >= releaseAge:
		timeColor = '{1,0,0,1}'
		shadeColor = '{0.3,0.3,0.3,1}'
	elif 7 >= releaseAge:
		timeColor = '{color7_R,color7_G,color7_B,color7_A}'
		shadeColor = '{color3_R,color3_G,color3_B,color3_A}'
	elif 14 >= releaseAge:
		timeColor = '{color8_R,color8_G,color8_B,color8_A}'
		shadeColor = '{color3_R,color3_G,color3_B,color3_A}'
	else:
		timeColor = '{color0_R,color0_G,color0_B,color0_A}'
		shadeColor = '{color3_R,color3_G,color3_B,color3_A}'
	#endif
	return [releaseAge, timeColor, shadeColor]
#enddef

#####################################

def main():
	global timeStart
	firstRun = True
	mUpdates_now = u""
	while True:
		timeStart = time.time()
		finalOutput = u"return { "
		### {ParseState, SeriesName, EpisodeNumber, GroupName, FileType, FileSize, EpisodeTitle}
		finalOutput = finalOutput + aniDB_Check()
		finalOutput = finalOutput + ' , ' + nyaaMusic_Check()
		finalOutput = finalOutput + ' , ' + conkyGit_191_Check()
		finalOutput = finalOutput + ' , ' + conkyGit_Master_Check()
		finalOutput = finalOutput + ' , ' + conkyGit_LuaConfig_Check()
		finalOutput = finalOutput + ' , ' + fluxbox_Master_Check()
		finalOutput = finalOutput + ' , ' + huginMercurial_Check()
		finalOutput = finalOutput + ' , ' + spacfm_Next_Check()
		finalOutput = finalOutput + ' , ' + udevil_Next_Check()
		finalOutput = finalOutput + ' , ' + mplayer2_Master_Check()
		finalOutput = finalOutput + ' , ' + mplayer2_Build_Check()
		finalOutput = finalOutput + ' , ' + smplayer2_Master_Check()
		finalOutput = finalOutput + ' , ' + deadbeef_Master_Check()
		finalOutput = finalOutput + ' , ' + dunst_Master_Check()
		finalOutput = finalOutput + ' , ' + octave_Mercurial_Check()
		finalOutput = finalOutput + ' , ' + kvirc_SVN_Check()
		try:
			mUpdates_now = mangaUpdates_Check(firstRun)
		except Exception, e:
			print "manga Updates Error: " + str(e)
			mUpdates_now = mUpdates_now
		#endtry
		finalOutput = finalOutput + ' , ' + mUpdates_now
		finalOutput = finalOutput + " }"
		######
		logfile = open((logDirectory + "/conky_unifiedRSS_CB10_lua_log.txt"), "w")
		logfile.write(finalOutput)
		logfile.close()
		######
		if firstRun == True:
			firstRun = False
		#endif
		print time.strftime('Last Update: %I:%M:%S %p',time.localtime(timeStart))
		timeEnd = time.time()
		timeDiff = timeEnd - timeStart
		#print timeDiff
		if (timeDiff) < 900 and timeDiff > 0:
			time.sleep(900 - timeDiff)
		#endif
	#endwhile
#enddef

main()
